function [A,B,ew] = QZAlgorithm(A,B,tol)

N = size(A,1);
n = N; 
while n > 2

  % find the last zero on the first subdiagonal
  last0 = 0; 
  for ell = 1:n-1
    if abs(A(ell+1,ell)) < tol * (abs(A(ell+1,ell+1)) + abs(A(ell,ell)))
      A(ell+1,ell) = 0;
      last0 = ell;
    end
  end

  % Work with subblocks A_{22} and B_{22}
  index = last0+1:n;
  if last0 < n-2   
    nz = find(abs(diag(B(index,index)))<1e-14,1,'last');
    if ~isempty(nz)
       % do push down 
    else
       % do QZ step
    end
  else
    n = last0;
  end
  
end


% Extract Eigenvalues
k=1;
ew = zeros(N,1);
while k< N
  % real eigenvalue
  if A(k+1,k)==0
    ew(k) = 0; % determine 
    k = k+1;
  % complex eigenvalue 
  else
    invB = 0; % determine inverse (do not use inv) 
    ew(k:k+1) = eig(invB*A(k:k+1,k:k+1));
    k=k+2;
  end
end
if k==N
  ew(k) = A(k,k)/B(k,k);
end

